--------------------------------------------------------------------------------
-- SubModule Accumulator_52
-- Created   8/14/2007 (capito che faccio invece di stare in vacanza?)
--------------------------------------------------------------------------------
library IEEE;
use IEEE.Std_Logic_1164.all;
use IEEE.Numeric_Std.all;

entity Accumulator_52 is
--   generic (
--     width    : natural := 48
--   );
   port (
     a        : in    std_logic_vector(63 downto 0);
     b        : out   std_logic_vector(63 downto 0);
     p        : in    std_logic_vector(63 downto 0);
     R        : in    std_logic;
     L        : in    std_logic;
     CLK      : in    std_logic;
     CE       : in    std_logic
   );
end Accumulator_52;
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
architecture RTL of Accumulator_52 is

   signal sum : signed(63 downto 0);

begin
   accu: process (CLK) is
   begin
      if rising_edge (CLK) then
         if CE = '1' then
            if R = '1' then
               sum <= (others => '0');
            elsif L = '1' then
               sum <= signed(p);
            else
               sum <= signed(a) + signed(sum);
            end if;
         end if;
      end if;
   end process accu;
   b <= std_logic_vector(sum);
end architecture RTL;
--------------------------------------------------------------------------------

