--------------------------------------------------------------------------------
-- SubModule OverflowDetect_52
-- Created   8/14/2007
--------------------------------------------------------------------------------
Library IEEE;
Use IEEE.Std_Logic_1164.all;

entity OverflowDetect_52 is port
   (
     a        : in    std_logic_vector(63 downto 0);
     b        : out   std_logic_vector(51 downto 0);
     IOVF     : in    std_logic;
     OVF      : out   std_logic
   );
end OverflowDetect_52;
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
architecture RTL of OverflowDetect_52 is

   signal overflow : std_logic;

begin
   -- detect overflow
   overflow <= '1' when (a(62) /= a(63)) or (a(61) /= a(63)) or
                        (a(60) /= a(63)) or (a(59) /= a(63)) or
                        (a(58) /= a(63)) or (IOVF = '1')
          else '0';
   OVF <= overflow;

   -- mark overflow in output
   mark: process (overflow, a) is
   begin
      if overflow = '1' then
         b <= (a(63), others => not a(63));
      else
         b <= a (58 downto 7);
      end if;
   end process mark;

end architecture RTL;
--------------------------------------------------------------------------------
