------------------------------------------------------------
-- VHDL LEDCtrl
-- 2016 5 5 8 48 35
-- Created By "DXP VHDL Generator"
-- "Copyright (c) 2002-2014 Altium Limited"
-- Product Version: 15.1.15.50867
------------------------------------------------------------

------------------------------------------------------------
-- VHDL LEDCtrl
------------------------------------------------------------

Library IEEE;
Use     IEEE.std_logic_1164.all;

Entity LEDCtrl Is
  port
  (
    X_1PPS : In    STD_LOGIC;                                -- ObjectKind=Port|PrimaryId=1PPS
    CLK    : In    STD_LOGIC;                                -- ObjectKind=Port|PrimaryId=CLK
    CNT    : In    STD_LOGIC_VECTOR(25 DOWNTO 0);            -- ObjectKind=Port|PrimaryId=CNT[25..0]
    GPS    : In    STD_LOGIC_VECTOR(31 DOWNTO 0);            -- ObjectKind=Port|PrimaryId=GPS[31..0]
    SYNC   : Out   STD_LOGIC_VECTOR(3 DOWNTO 0)              -- ObjectKind=Port|PrimaryId=SYNC[3..0]
  );
  attribute MacroCell : boolean;

End LEDCtrl;
------------------------------------------------------------

------------------------------------------------------------
Architecture Structure Of LEDCtrl Is
   Component Configurable_U_LED                              -- ObjectKind=Part|PrimaryId=U_LED|SecondaryId=1
      port
      (
        LEDBLINK : out STD_LOGIC;                            -- ObjectKind=Pin|PrimaryId=U_LED-LEDBLINK
        LEDMUL   : out STD_LOGIC_VECTOR(3 downto 0)          -- ObjectKind=Pin|PrimaryId=U_LED-LEDMUL[3..0]
      );
   End Component;

   Component Configurable_U_LED1                             -- ObjectKind=Part|PrimaryId=U_LED1|SecondaryId=1
      port
      (
        I0 : in  STD_LOGIC;                                  -- ObjectKind=Pin|PrimaryId=U_LED1-I0
        I1 : in  STD_LOGIC;                                  -- ObjectKind=Pin|PrimaryId=U_LED1-I1
        I2 : in  STD_LOGIC;                                  -- ObjectKind=Pin|PrimaryId=U_LED1-I2
        I3 : in  STD_LOGIC;                                  -- ObjectKind=Pin|PrimaryId=U_LED1-I3
        O  : out STD_LOGIC_VECTOR(3 downto 0)                -- ObjectKind=Pin|PrimaryId=U_LED1-O[3..0]
      );
   End Component;

   Component LedDiag                                         -- ObjectKind=Sheet Symbol|PrimaryId=U_LEDDIAG
      port
      (
        BLINK  : in  STD_LOGIC;                              -- ObjectKind=Sheet Entry|PrimaryId=LedDiag.Vhd-BLINK
        CLK    : in  STD_LOGIC;                              -- ObjectKind=Sheet Entry|PrimaryId=LedDiag.Vhd-CLK
        CNT    : in  STD_LOGIC_VECTOR(25 downto 0);          -- ObjectKind=Sheet Entry|PrimaryId=LedDiag.Vhd-CNT[25..0]
        DIV    : in  STD_LOGIC_VECTOR(3 downto 0);           -- ObjectKind=Sheet Entry|PrimaryId=LedDiag.Vhd-DIV[3..0]
        GPS    : in  STD_LOGIC_VECTOR(31 downto 0);          -- ObjectKind=Sheet Entry|PrimaryId=LedDiag.Vhd-GPS[31..0]
        ONEPPS : in  STD_LOGIC;                              -- ObjectKind=Sheet Entry|PrimaryId=LedDiag.Vhd-ONEPPS
        SYNC   : out STD_LOGIC;                              -- ObjectKind=Sheet Entry|PrimaryId=LedDiag.Vhd-SYNC
        UP     : out STD_LOGIC                               -- ObjectKind=Sheet Entry|PrimaryId=LedDiag.Vhd-UP
      );
   End Component;


    Signal PinSignal_U_LED_LEDBLINK : STD_LOGIC; -- ObjectKind=Net|PrimaryId=NetU_LED_LEDBLINK
    Signal PinSignal_U_LED_LEDMUL   : STD_LOGIC_VECTOR(3 downto 0); -- ObjectKind=Net|PrimaryId=NetU_LED_LEDMUL[3..0]
    Signal PinSignal_U_LED1_O       : STD_LOGIC_VECTOR(3 downto 0); -- ObjectKind=Net|PrimaryId=SYNC[3..0]
    Signal PinSignal_U_LEDDIAG_SYNC : STD_LOGIC; -- ObjectKind=Net|PrimaryId=NetU_LED1_I2
    Signal PinSignal_U_LEDDIAG_UP   : STD_LOGIC; -- ObjectKind=Net|PrimaryId=NetU_LED1_I3
    Signal PowerSignal_GND          : STD_LOGIC; -- ObjectKind=Net|PrimaryId=GND

Begin
    U_LEDDIAG : LedDiag                                      -- ObjectKind=Sheet Symbol|PrimaryId=U_LEDDIAG
      Port Map
      (
        BLINK  => PinSignal_U_LED_LEDBLINK,                  -- ObjectKind=Sheet Entry|PrimaryId=LedDiag.Vhd-BLINK
        CLK    => CLK,                                       -- ObjectKind=Sheet Entry|PrimaryId=LedDiag.Vhd-CLK
        CNT    => CNT,                                       -- ObjectKind=Sheet Entry|PrimaryId=LedDiag.Vhd-CNT[25..0]
        DIV    => PinSignal_U_LED_LEDMUL,                    -- ObjectKind=Sheet Entry|PrimaryId=LedDiag.Vhd-DIV[3..0]
        GPS    => GPS,                                       -- ObjectKind=Sheet Entry|PrimaryId=LedDiag.Vhd-GPS[31..0]
        ONEPPS => X_1PPS,                                    -- ObjectKind=Sheet Entry|PrimaryId=LedDiag.Vhd-ONEPPS
        SYNC   => PinSignal_U_LEDDIAG_SYNC,                  -- ObjectKind=Sheet Entry|PrimaryId=LedDiag.Vhd-SYNC
        UP     => PinSignal_U_LEDDIAG_UP                     -- ObjectKind=Sheet Entry|PrimaryId=LedDiag.Vhd-UP
      );

    U_LED1 : Configurable_U_LED1                             -- ObjectKind=Part|PrimaryId=U_LED1|SecondaryId=1
      Port Map
      (
        I0 => PowerSignal_GND,                               -- ObjectKind=Pin|PrimaryId=U_LED1-I0
        I1 => PowerSignal_GND,                               -- ObjectKind=Pin|PrimaryId=U_LED1-I1
        I2 => PinSignal_U_LEDDIAG_SYNC,                      -- ObjectKind=Pin|PrimaryId=U_LED1-I2
        I3 => PinSignal_U_LEDDIAG_UP,                        -- ObjectKind=Pin|PrimaryId=U_LED1-I3
        O  => PinSignal_U_LED1_O                             -- ObjectKind=Pin|PrimaryId=U_LED1-O[3..0]
      );

    U_LED : Configurable_U_LED                               -- ObjectKind=Part|PrimaryId=U_LED|SecondaryId=1
      Port Map
      (
        LEDBLINK => PinSignal_U_LED_LEDBLINK,                -- ObjectKind=Pin|PrimaryId=U_LED-LEDBLINK
        LEDMUL   => PinSignal_U_LED_LEDMUL                   -- ObjectKind=Pin|PrimaryId=U_LED-LEDMUL[3..0]
      );

    -- Signal Assignments
    ---------------------
    PowerSignal_GND <= '0'; -- ObjectKind=Net|PrimaryId=GND
    SYNC            <= PinSignal_U_LED1_O; -- ObjectKind=Net|PrimaryId=SYNC[3..0]

End Structure;
------------------------------------------------------------

