-------------------------------------------------------------------------------
-- SubModule Reg52
-- Created   08/22/2007
--------------------------------------------------------------------------------
library IEEE;
use IEEE.Std_Logic_1164.all;

entity Reg52_52 is port
   (
     a        : in    std_logic_vector(51 downto 0);
     b        : out   std_logic_vector(51 downto 0);
     RST      : in    std_logic;
     CLK      : in    std_logic;
     EN       : in    std_logic;    -- line command c(6)
     WE       : out   std_logic     --  line command c(6) to SmallHistory
   );
end Reg52_52;
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
architecture RTL of Reg52_52 is

 signal cl1 : std_logic;
 signal cl2 : std_logic;
 signal cl3 : std_logic;
 signal cl4 : std_logic;
 signal reg : std_logic_vector(51 downto 0);

begin
 cl1 <=  EN when rising_edge(CLK);
 cl2 <= cl1 when rising_edge(CLK);
 cl3 <= cl2 when rising_edge(CLK);
 cl4 <= cl3 when rising_edge(CLK);
 WE <= cl4 or RST;

 prif: process (EN, CLK) is
   begin
   if rising_edge (CLK) then
   if EN = '1' then
      reg <= a;
   end if;
   end if;
 end process prif;

 b <= reg when RST = '0' else (others => '0');

end architecture RTL;
--------------------------------------------------------------------------------
